> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Retrieve SKU

GET https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/sku/{skuId}

Retrieve a specific SKU (Stock Keeping Unit) by ID.

SKUs represent unique hardware configurations discovered at sites. They are automatically derived from machine characteristics.

For Infrastructure Providers: Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER` role.

For Tenants: Org must have a Tenant with `TargetedInstanceCreation` capability enabled. User must have `FORGE_TENANT_ADMIN` role. The Tenant must have an account with the SKU's Site's Infrastructure Provider.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/sku/get-sku

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/sku/{skuId}:
    get:
      operationId: get-sku
      summary: Retrieve SKU
      description: >-
        Retrieve a specific SKU (Stock Keeping Unit) by ID.


        SKUs represent unique hardware configurations discovered at sites. They
        are automatically derived from machine characteristics.


        For Infrastructure Providers: Org must have an Infrastructure Provider
        entity. User must have `FORGE_PROVIDER_ADMIN` or `FORGE_PROVIDER_VIEWER`
        role.


        For Tenants: Org must have a Tenant with `TargetedInstanceCreation`
        capability enabled. User must have `FORGE_TENANT_ADMIN` role. The Tenant
        must have an account with the SKU's Site's Infrastructure Provider.
      tags:
        - subpackage_sku
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: skuId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Sku'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '404':
          description: Error response when requested object is not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    SkuCpu:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the CPU
        model:
          type: string
          description: Model of the CPU
        threadCount:
          type: integer
          format: uint
          description: Number of threads for the CPU
        count:
          type: integer
          format: uint
          description: Number of CPUs present
      description: CPU component in a SKU
      title: SkuCpu
    SkuGpu:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the GPU
        model:
          type: string
          description: Model of the GPU
        totalMemory:
          type: string
          description: Total memory of the GPU (e.g. "80GB HBM3")
        count:
          type: integer
          format: uint
          description: Number of GPUs present
      description: GPU component in a SKU
      title: SkuGpu
    SkuMemory:
      type: object
      properties:
        capacityMb:
          type: integer
          format: uint
          description: Capacity in megabytes
        memoryType:
          type: string
          description: Type of memory (e.g. "DDR4", "DDR5")
        count:
          type: integer
          format: uint
          description: Number of memory modules present
      description: Memory component in a SKU
      title: SkuMemory
    SkuStorage:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the storage device
        model:
          type: string
          description: Model of the storage device
        capacityMb:
          type: integer
          format: uint
          description: Capacity in megabytes
        count:
          type: integer
          format: uint
          description: Number of storage devices present
      description: Storage component in a SKU
      title: SkuStorage
    SkuChassis:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the chassis
        model:
          type: string
          description: Model of the chassis
      description: Chassis component in a SKU
      title: SkuChassis
    SkuEthernetDevice:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the ethernet device
        model:
          type: string
          description: Model of the ethernet device
        count:
          type: integer
          format: uint
          description: Number of ethernet devices present
      description: Ethernet device component in a SKU
      title: SkuEthernetDevice
    SkuInfinibandDevice:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the infiniband device
        model:
          type: string
          description: Model of the infiniband device
        count:
          type: integer
          format: uint
          description: Number of infiniband devices present
      description: Infiniband device component in a SKU
      title: SkuInfinibandDevice
    SkuTpm:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the TPM
        model:
          type: string
          description: Model of the TPM
        count:
          type: integer
          format: uint
          description: Number of TPMs present
      description: TPM component in a SKU
      title: SkuTpm
    SkuComponents:
      type: object
      properties:
        cpus:
          type: array
          items:
            $ref: '#/components/schemas/SkuCpu'
          description: CPU components
        gpus:
          type: array
          items:
            $ref: '#/components/schemas/SkuGpu'
          description: GPU components
        memory:
          type: array
          items:
            $ref: '#/components/schemas/SkuMemory'
          description: Memory components
        storage:
          type: array
          items:
            $ref: '#/components/schemas/SkuStorage'
          description: Storage components
        chassis:
          $ref: '#/components/schemas/SkuChassis'
          description: Chassis component
        ethernetDevices:
          type: array
          items:
            $ref: '#/components/schemas/SkuEthernetDevice'
          description: Ethernet device components
        infinibandDevices:
          type: array
          items:
            $ref: '#/components/schemas/SkuInfinibandDevice'
          description: Infiniband device components
        tpm:
          type: array
          items:
            $ref: '#/components/schemas/SkuTpm'
          description: TPM components
      description: Hardware components that make up a SKU
      title: SkuComponents
    Sku:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the SKU
        siteId:
          type: string
          format: uuid
          description: ID of the Site this SKU belongs to
        deviceType:
          type:
            - string
            - 'null'
          description: Optional device type identifier (e.g. "gpu", "cpu", "storage")
        associatedMachineIds:
          type: array
          items:
            type: string
          description: List of machine IDs associated with this SKU
        components:
          $ref: '#/components/schemas/SkuComponents'
          description: Hardware components of this SKU
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the SKU was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the SKU was last updated
      description: >-
        A SKU (Stock Keeping Unit) represents a unique hardware configuration
        discovered at a site.

        SKUs are automatically derived from machine hardware characteristics and
        used to group similar machines.
      title: Sku
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/sku/skuId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```